/* GMSD - Group Membership Service Daemon
 * Copyright (C) 2003 Nelio Pereira (nelio@ime.usp.br)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

#ifndef _CMDLINE_H
#define _CMDLINE_H

#include <glib.h>

/*! Command line arguments, in the format required by getopt. */
#define CMDLINE_OPTS "hc:gd"

/*! A structure describing what was passed through the command line. */ 
typedef struct {
  gchar* cmd;
  gchar* config_filename;
  gboolean debug;
  gboolean daemon;
} cmdline_t;

void cmdline_init(void);
void cmdline_finalize(void);
gboolean cmdline_enabled(void);

cmdline_t* cmdline_new(void);
void cmdline_destroy(cmdline_t*);

void cmdline_usage(const gchar* const);
gboolean cmdline_parse(const guint, gchar** const);

#endif /* cmdline.h */
