/* GMSD - Group Membership Service Daemon
 * Copyright (C) 2003 Nelio Pereira (nelio@ime.usp.br)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

#ifndef _COMPAT_H
#define _COMPAT_H

/*! Compilation definitions */
#include "config.h"

#ifdef GLIB2_2

#include <glib/gprintf.h>
#define G_PRINTF  g_printf
#define G_FPRINTF g_fprintf

#define G_STR_HAS_PREFIX g_str_has_prefix

#else

#include <stdio.h>
#define G_PRINTF  printf
#define G_FPRINTF fprintf

#include <string.h>
#define G_STR_HAS_PREFIX(str,prefix)  (strncmp(str,prefix,strlen(prefix)) == 0)

#endif


#endif /* glib2_compat.h */
