/* GMSD - Group Membership Service Daemon
 * Copyright (C) 2003 Nelio Pereira (nelio@ime.usp.br)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

#ifndef _GROUP_H
#define _GROUP_H

//#include <glib.h>
//#include <libxml/tree.h>

#include "node.h"


/*! A group of computers. */
typedef struct {
  GList *members;   /*!< The members of the group. */
  guint size;       /*!< The size of the group. */
} group_t;


group_t* group_new(void);
void group_destroy(group_t*);
void group_destroy_full(group_t*);

guint group_size(const group_t* const); 
gboolean group_in(const group_t* const, const node_t* const);
void group_add_node(group_t* const, node_t* const);
void group_remove_node(group_t* const, const node_t* const);
void group_print(const group_t* const);
gchar* group_to_string(const group_t* const);
node_t* group_find(const group_t* const group, const node_t* const node);

xmlDocPtr group_to_xml(const group_t* const);
group_t* group_from_xml(const xmlDocPtr);


#endif /* group.h */
