/* GMSD - Group Membership Service Daemon
 * Copyright (C) 2003 Nelio Pereira (nelio@ime.usp.br)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

#ifndef _PROTOCOL_H
#define _PROTOCOL_H

#include <time.h>

//#include <glib.h>

//#include "group_id.h"
#include "membership.h"
#include "msg.h"
//#include "node.h"

/*! Default timeout for the \em neighbor timer (milliseconds). */ 
#define PROTOCOL_TIMEOUT_NEIGHBOR_DEFAULT 5000
/*! Default timeout for the \em probe timer (milliseconds). */
#define PROTOCOL_TIMEOUT_PROBE_DEFAULT 5000
/*! Default timeout for the \em delay timer (milliseconds). */
#define PROTOCOL_TIMEOUT_DELAY_DEFAULT 5000

/*! The definition of a \em New-Group message type. */
#define PROTOCOL_MSG_NEW_GROUP 1
/*! The definition of a \em I-Am-Alive message type. */
#define PROTOCOL_MSG_ALIVE 2
/*! The definition of a \em Probe message type. */
#define PROTOCOL_MSG_PROBE 3


void protocol_init(const gchar* const, const guint, const guint, const guint);
void protocol_finalize(void);
gboolean protocol_enabled(void);

void protocol_handle_msg_new_group(const msg_t* const);
void protocol_handle_msg_alive(const msg_t* const);
void protocol_handle_msg_probe(const msg_t* const);

#endif /* protocol.h */
