/* GMSD - Group Membership Service Daemon
 * Copyright (C) 2003 Nelio Pereira (nelio@ime.usp.br)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

//#include <glib.h>
#include <libxml/tree.h>

#include "log.h" 
#include "xml.h"


/*! */
static gboolean enabled = FALSE;


/**
 *
 */
void xml_init()
{
  log_debug("[xml init] init");

  xmlSetCompressMode(XML_COMPRESSION_MODE);
  enabled = TRUE;

  log_debug("[xml init] exit");
}


/**
 *
 */
void xml_finalize()
{
  log_debug("[xml finalize] init");

  enabled = FALSE;

  log_debug("[xml finalize] exit");
}


/**
 *
 */
gboolean xml_enabled()
{
  return enabled;
}
