/* GMSD - Group Membership Service Daemon
 * Copyright (C) 2003 Nelio Pereira (nelio@ime.usp.br)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

#ifndef _XML_H
#define _XML_H

#include <glib.h>


/*! */
#define XML_VERS "1.0"

/*! */
#define XML_NODE "node"

/*! */
#define XML_NODE_ID "id"

/*! */
#define XML_NODE_HOSTNAME "hostname"

/*! */
#define XML_NODE_PORT "port"

/*! */
#define XML_GROUP_ID "group-id"

/*! */
#define XML_GROUP_ID_SEQUENCE "sequence"

/*! */
#define XML_GROUP_ID_NODE_ID "node-id"

/*! */
#define XML_GROUP "group"

/*! */
#define XML_GROUP_SIZE "size"

/*! */
#define XML_GROUP_MEMBERS "members"

/*! */
#define XML_MEMBERSHIP "membership"

/*! */
#define XML_MEMBERSHIP_TIMESTAMPS "timestamps"

/*! */
#define XML_MEMBERSHIP_TIMESTAMPS_NODE "node"

/*! */
#define XML_MEMBERSHIP_TIMESTAMPS_NODE_ID "id"

/*! */
#define XML_MESSAGE "message"

/*! */
#define XML_MESSAGE_ID "id"

/*! */
#define XML_MESSAGE_HEADER "header"

/*! */
#define XML_MESSAGE_HEADER_FROM "from"

/*! */
#define XML_MESSAGE_HEADER_TO "recipient"

/*! */
#define XML_MESSAGE_HEADER_TO_TYPE "type"

/*! */
#define XML_MESSAGE_HEADER_TYPE "type"

/*! */
#define XML_MESSAGE_DATA "data"

/*! */
#define XML_TIMESTAMP "timestamp"


/*! The compression mode applied in XML serialization. */
#define XML_COMPRESSION_MODE 7


void xml_init(void);
void xml_finalize(void);
gboolean xml_enabled(void);

#endif /* xml.h */
