#!/usr/bin/perl

#
# Nelio Pereira - nelio@ime.usp.br
# 2003-08-04
#
# create_nodes_config.pl
# Creates the nodes configuration file.
#
#

use Getopt::Std;

require 'misc/libutil.pl';


sub usage 
{
    print "Usage: $0 [-h] [-l] -n <number of nodes>\n";
    print "       -h: this help message\n";
    print "       -l: create a \"local\" group of processes\n"; 
    print "\n";
    exit;
}




####################
# MAIN
###################################

getopts('n:lh');

if ($opt_h || ! $opt_n) {
    usage;
}

$number_of_nodes = $opt_n;
$local = $opt_l;

$nodename = &get_nodename;

# lets erase the content of the nodes list configuration
truncate ${NODES_CONF_FILE}, 0;

# the initial value for the communication port
$comm_port = 30000;

open CONF, ">".${NODES_CONF_FILE} || die $!;
select CONF;

if ($local) {
    foreach $i (${comm_port}+1..${comm_port}+${number_of_nodes}) {
	print "${nodename}\t$i\n";
    }
} else {
    print "$nodename\t$comm_port\n";
    foreach $i (1..${number_of_nodes}) {
	print "node${i}.${nodename}\t${comm_port}\n";
    }
}

close CONF;
