#!/usr/bin/perl

use strict;
use Data::Dumper;

require 'libparse.pl';

sub usage
{
    print "Usage: $0 <log file to be analyzed> <d/p>\n";
    print "\n";
    exit;
}


##################
# MAIN
###########

if (int(@ARGV) != 2) {
    &usage;
}

my ($events, $table);

$events = parse_log($ARGV[0]);

$table = consolidate_events($events);

if ($ARGV[1] eq 'd') {
    $Data::Dumper::Varname = 'dump';
    $Data::Dumper::Purity = 1;
    print Dumper($table);
} elsif ($ARGV[1] eq 'p') {
    print_events($table);
} else {
    print "Unknown action option: $ARGV[1]\n";
    exit;
}
