#!/usr/bin/perl

use Statistics::Descriptive;

sub usage
{
    print "Usage: $0 <quantidade de grupos> <plot1> <plot2> ... <plotn>\n";
    print "\n";
    exit;
}


sub parse_plot
{
    local ($file) = @_;
    local ($line, $cont, %records);

    open ARQ, $file or die "Nao pude abrir '$file': $!";
    
    $cont = 1;
    while ($line=<ARQ>) {
	local ($i);

	$re = '^' . $cont;
	foreach (1..$groups) {
	    $re .= '\t([^\t]+)\t([^\t]+)\t([^\t]+)';
	}
	$re .= "\n\$";

	if ($line !~ /$re/) {
	    print STDERR "ERRO - $file: $line";
	    exit;
	}

	foreach $i (1..$groups) {
	    $x = 3*$i - 2;
#	    next if ($$x eq '-'); 

	    $records{$cont}->{$i}->{'M'} = $$x;
	    $x++;
	    $records{$cont}->{$i}->{'G'} = $$x;
	    $x++;
	    $records{$cont}->{$i}->{'gid-count'} = $$x;
	}

	$cont++;
    }
    
    close ARQ;

    return \%records;
}



####################################3

if (int(@ARGV) < 2) {
    &usage;
}


local $groups = shift @ARGV;

%plots = ();

foreach $file (@ARGV) {
    $plots{$file} = parse_plot $file;
}

foreach $group (1..$groups) {
    
    print $group;
    
    foreach $node (1..$groups) {
	local ($m_stat, $g_stat);
	
	$m_stat = Statistics::Descriptive::Full->new();
	$g_stat = Statistics::Descriptive::Full->new();
	$gc_stat = Statistics::Descriptive::Full->new();

	$saiu = 0;
	foreach $key (keys %plots) {
	    if ($plots{$key}->{$group}->{$node}->{'M'} eq '-') {
		$saiu = 1;
		next;
	    }
	    $m_stat->add_data($plots{$key}->{$group}->{$node}->{'M'});
	    $g_stat->add_data($plots{$key}->{$group}->{$node}->{'G'});
	    $gc_stat->add_data($plots{$key}->{$group}->{$node}->{'gid-count'});
	} 
	
	if ($saiu) {
	    print "\t-\t-\t-\t-\t-\t-";
	} else {
	    printf "\t%.3f\t%.3f\t%.3f\t%.3f\t%.2f\t%.2f", 
		    $m_stat->median(), 
		    $m_stat->max(),
		    $g_stat->median(),
		    $g_stat->max(),
		    $gc_stat->median(),
		    $gc_stat->max();
#	    printf "\t%.3f\t%.3f", $m_stat->mean(), $g_stat->mean();
	}
    }

    print "\n";
}


