#!/bin/bash

. ../../bin/libtest.sh


echo "--> FINALIZACAO - MULTIPLA - PRIMEIRO NO"
echo

#
# Primeiro deixando s o primeiro
#

for k in `seq 1 $_N_REP`; do
    echo -ne "\t\t--> Rodando experimento $k <--\n"

    run-finalizacao-multipla "1"

    aux=`printf "%.3d" $k`
    mv log log-$aux
    pushd ..
    ./gera_plot.pl $_GERA_PLOT_OPT -f $OLDPWD/log-$aux/logao > $OLDPWD/log-$aux/plot-groups.dat
    ./gera_plot.pl $_GERA_PLOT_OPT -n -f $OLDPWD/log-$aux/logao > $OLDPWD/log-$aux/plot-nodes.dat
    popd
done

# gerando resultados finais
mkdir resultados

# calcula as medias
../../bin/gera_media.pl $_N_NODES log-*/plot-groups.dat > resultados/plot-groups.dat
../../bin/gera_media.pl $_N_NODES log-*/plot-nodes.dat > resultados/plot-nodes.dat

# gera os graficos
gera_graph "resultados"

mkdir 1
mv log* 1
mv resultados 1


echo "--> FINALIZACAO - MULTIPLA - ULTIMO NO"
echo

#
# Agora deixando s o ultimo
#

for k in `seq 1 $_N_REP`; do
    echo -ne "\t\t--> Rodando experimento $k <--\n"

    run-finalizacao-multipla "$_N_NODES"

    aux=`printf "%.3d" $k`
    mv log log-$aux
    pushd ..
    ./gera_plot.pl $_GERA_PLOT_OPT -f $OLDPWD/log-$aux/logao > $OLDPWD/log-$aux/plot-groups.dat
    ./gera_plot.pl $_GERA_PLOT_OPT -n -f $OLDPWD/log-$aux/logao > $OLDPWD/log-$aux/plot-nodes.dat
    popd
done

# gerando resultados finais
mkdir resultados

# calcula as medias
../../bin/gera_media.pl $_N_NODES log-*/plot-groups.dat > resultados/plot-groups.dat
../../bin/gera_media.pl $_N_NODES log-*/plot-nodes.dat > resultados/plot-nodes.dat

# gera os graficos
gera_graph "resultados"

mkdir ${_N_NODES}
mv log* ${_N_NODES}
mv resultados ${_N_NODES}


